/**
 * D'accord Music Software
 * http://www.daccord.com.br
 *
 * D'accord Violo
 * Classe RepositorioEventos
 *
 * Verso: 29/05/2001, 14:00
 */
#include <vcl.h>
#include <stdio.h>
#include "SaidaMIDI.h"
#include "Braco.h"
#include "RepositorioEventos.h"


#pragma hdrstop
#pragma package(smart_init)

RepositorioAcordes *acordes;
Cabecalho *cabecalho;

/*//
FILE *logFile; // arquivo de log.
//*/

/**
 * Construtor da Classe
 *
 * Parmetros:
 *     char *nomeArquivo    Nome e caminho do arquivo da msica que inicializar
 *                          o repositorio.
 */
RepositorioEventos::RepositorioEventos(char *nomeArquivo, TMemo *caixaLetra)
{
    this->nomeArquivo = nomeArquivo;
    arquivoMusica = new ArquivoMusica(nomeArquivo, &acordes, &notas, &ritmos,
                &letra, &andamento, &cabecalho, caixaLetra, &selecaoAcordeMemo);
    exibicaoMelodia = NULL;
    inicializar();
    delete arquivoMusica;
}


/**
 *
 */
RepositorioEventos::~RepositorioEventos()
{
    /*//
    logFile = fopen("dvlog.log", "a");
    fprintf(logFile, "RepositorioEventos: deletando a hash table\n");
    fclose(logFile);
    //*/
    limpar();
    /*//
    logFile = fopen("dvlog.log", "a");
    fprintf(logFile, "RepositorioEventos: hash table deletada\n\tLimpando acordes\n");
    fclose(logFile);
    //*/
    delete acordes;
    acordes = NULL;
    /*//
    logFile = fopen("dvlog.log", "a");
    fprintf(logFile, "RepositorioEventos: acordes deletados\n\tLimpando notas\n");
    fclose(logFile);
    //*/
    delete notas;
    notas = NULL;
    /*//
    logFile = fopen("dvlog.log", "a");
    fprintf(logFile, "RepositorioEventos: notas deletadas\n\tLimpando ritmos\n");
    fclose(logFile);
    //*/
    delete ritmos;
    ritmos = NULL;
    /*//
    logFile = fopen("dvlog.log", "a");
    fprintf(logFile, "RepositorioEventos: ritmos deletados\n\tLimpando letra\n");
    fclose(logFile);
    //*/
    delete letra;
    letra = NULL;
    /*//
    logFile = fopen("dvlog.log", "a");
    fprintf(logFile, "RepositorioEventos: letra deletada\n\tLimpando andamento\n");
    fclose(logFile);
    //*/
    delete andamento;
    andamento = NULL;
    /*//
    logFile = fopen("dvlog.log", "a");
    fprintf(logFile, "RepositorioEventos: andamento deletado\n\tLimpando cabecalho\n");
    fclose(logFile);
    //*/
    delete cabecalho;
    cabecalho = NULL;
    /*//
    logFile = fopen("dvlog.log", "a");
    fprintf(logFile, "RepositorioEventos: cabecalho deletado\n");
    fclose(logFile);
    //*/
}


/**
 *
 */
void RepositorioEventos::limpar()
{
    int tamanho = cabecalho->getTempoTotal();
    int i, j;

    for (i = 0; i < tamanho; i++)
    {
        if (dicionario[i] != NULL)
        {
            // deleta os items de cada lista
            for (j = (dicionario[i]->Count - 1); j >= 0; j--)
            {   // deleta os ElementoListaEventos's
                delete dicionario[i]->Items[j];
            }
            // limpa a lista
            dicionario[i]->Clear();
            // deleta a lista
            delete dicionario[i];
            dicionario[i] = NULL;
        }
    }
    // deleta o dicionario
    delete dicionario;
    dicionario = NULL;
}


/**
 *
 */
void RepositorioEventos::tocar(long timestamp)
{
    int tamanho;
    int i;
    ElementoListaEventos *temp;

    // checar se o timestamp  valido

    if (dicionario[timestamp] != NULL)
    {
        tamanho = dicionario[timestamp]->Count;
        for (i = 0; i < tamanho; i++)
        {   // acrescentar os outros tipos: mudar para switch
            temp = (ElementoListaEventos *)dicionario[timestamp]->Items[i];
            if (temp != NULL)
            {
                switch (temp->tipo)
                {
                    case ON:
                    /*
                        #ifndef DEBUGANDO
                        ArquivoLog::tempo();
                        #endif
                    */
                        temp->evento->on();
                    /*
                        #ifndef DEBUGANDO
                        ArquivoLog::tempo();
                        #endif
                    */
                        break;
                    case OFF:
                    /*
                        #ifndef DEBUGANDO
                        ArquivoLog::tempo();
                        #endif
                    */
                        temp->evento->off();
                    /*
                        #ifndef DEBUGANDO
                        ArquivoLog::tempo();
                        #endif
                    */
                        break;
                    default:
                        /*//
                        logFile = fopen("dvlog.log", "a");
                        fprintf(logFile, "RepositorioEventos: tocar() (temp->tipo = %d)\n", temp->tipo);
                        fclose(logFile);
                        //*/
                        break;
                }
            }
        }
    }
}


/**
 *
 */
void RepositorioEventos::setPosicaoAtual(long timestamp)
{
    andamento->setPosicaoAtual(timestamp);
    acordes->setPosicaoAtual(timestamp);
    letra->setPosicaoAtual(timestamp);

}


/**
 * Inicializa o Repositorio, setando o cabealho, criando as listas de acordes e
 * notas, e a letra, alm de inicializar o dicionrio de apontadores para
 * mtodos on's e off's dos eventos.
 */
void RepositorioEventos::inicializar()
{
    bool condicao = true;
    ListaEventos *temp;
    ElementoEvento *temp2;
    int tamanho;
    /* setar as variaveis do cabecalho: talvez isto deva ser feito no form
     * principal */
    //...

    /* Monta a Hash Table */
    tamanho = cabecalho->getTempoTotal() + 1;
    dicionario = new TList*[tamanho];
    for (int i = 0; i < tamanho; i++)
    {
        dicionario[i] = NULL;
    }
    // organiza a seleo da letra, garantindo o scroll.
//    letra->organizarSelecoes();
//    notas->ordenar();
//    acordes->ordenar();
    ritmos->montarRepositorio();
//    andamento->ordenar();


    // Mandara o repositorio notas inicializar os eventos de Exibicao da melodia
    if (exibicaoMelodia != NULL) {
        delete exibicaoMelodia;
    }
    exibicaoMelodia = new ExibicaoMelodia();
    notas->preencherEventosExibicaoMelodia(&exibicaoMelodia);
    exibicaoMelodia->gerarSolo();

    // insere os eventos Nota::off
    while (condicao)
    {
        temp = notas->getEventosOff();
        if (temp->timestamp != FIM_REPOSITORIO) // se existirem eventos
        {
            inserirListaEventos(temp);
        }
        else
        {
            condicao = false;
        }
        delete temp;
    }
    condicao = true;
    // insere os eventos NotaRitmo::off
    while (condicao)
    {
        temp = ritmos->getEventosOff();
        if (temp->timestamp != FIM_REPOSITORIO) // se existirem eventos
        {
            inserirListaEventos(temp);
        }
        else
        {
            condicao = false;
        }
        delete temp;
    }
    condicao = true;
    // insere os eventos Andamento::on
    while (condicao)
    {
        temp2 = andamento->getEventoOn();
        if (temp2->timestamp != FIM_REPOSITORIO) // se existirem eventos
        {
            this->inserirEvento(temp2);
        }
        else
        {
            condicao = false;
        }
    }
    condicao = true;
    // insere os eventos Acorde::on
    while (condicao)
    {
        temp2 = acordes->getEventoOn();
        if (temp2->timestamp != FIM_REPOSITORIO) // se existirem eventos
        {
            this->inserirEvento(temp2);
        }
        else
        {
            condicao = false;
        }
    }
    condicao = true;
    // insere os eventos NotaRitmo::on
    while (condicao)
    {
        temp = ritmos->getEventosOn();
        if (temp->timestamp != FIM_REPOSITORIO) // se existirem eventos
        {
            inserirListaEventos(temp);
        }
        else
        {
            condicao = false;
        }
        delete temp;
    }
    condicao = true;
    // insere os eventos Nota::on
    while (condicao)
    {
        temp = notas->getEventosOn();
        if (temp->timestamp != FIM_REPOSITORIO) // se existirem eventos
        {
            inserirListaEventos(temp);
        }
        else
        {
            condicao = false;
        }
        delete temp;
    }
    condicao = true;
    // insere os eventos Letra::on
    while (condicao)
    {
        temp = letra->getEventosOn();
        if (temp->timestamp != FIM_REPOSITORIO) // se existirem eventos
        {
            inserirListaEventos(temp);
        }
        else
        {
            condicao = false;
        }
        delete temp;
    }
    condicao = true;

    // insere os eventos ExibicaoMelodia::on
    while (condicao)
    {
        temp = exibicaoMelodia->getEventosExibicaoMelodia();
        if (temp->timestamp != FIM_REPOSITORIO) // se existirem eventos
        {
            inserirListaEventos(temp);
        }
        else
        {
            condicao = false;
        }
        delete temp;
    }

}


/**
 * Concatena a lista de eventos no dicionrio.
 */
void RepositorioEventos::inserirListaEventos(ListaEventos *eventos)
{
    int tamanho = eventos->eventos->Count;
    int i = 0;

    if (dicionario[eventos->timestamp] == NULL)
    {
        dicionario[eventos->timestamp] = new TList;
        dicionario[eventos->timestamp]->Clear();
    }
    // Insere os eventos, concatenando a lista recebida com a que j existe.
    while (i < tamanho)
    {
        dicionario[eventos->timestamp]->Add(eventos->eventos->Items[i]);
        i++;
    }
}


/**
 * Insere um elemento no dicionrio.
 */
void RepositorioEventos::inserirEvento(ElementoEvento *evento)
{
    if (dicionario[evento->timestamp] == NULL)
    {
        dicionario[evento->timestamp] = new TList;
        dicionario[evento->timestamp]->Clear();
    }
    // Insere o evento.
    dicionario[evento->timestamp]->Add(evento);
}

void RepositorioEventos::redesenhar() {
     selecaoAcordeMemo->redesenhar();
}

void RepositorioEventos::transpor(int direcao, int numSemitons)
{
TList* nomesNovosAcordes = new TList;
int i;
Acorde* acordeTemp;

    acordes->transpor(direcao,numSemitons);

    notas->transpor(direcao,numSemitons);
    exibicaoMelodia->gerarSolo();

    for(i = 0; i < acordes->eventos->Count; i++) {
        acordeTemp = ((EventoAcorde*)acordes->eventos->Items[i])->acorde;
        nomesNovosAcordes->Add(acordeTemp->getNome());
    }
    letra->ajustarTransposicao(nomesNovosAcordes);
    // Ajusta a lista q guarda os inicios das linhas
    letra->setInicioLinhas();

    acordes->setSelAcordes();
}

