/**
 * D'accord Music Software
 * http://www.daccord.com.br
 *
 * D'accord Violo
 * Definio da Classe RepositorioEventos
 *
 * Verso: 29/05/2001, 16:00
 */
#ifndef REPOSITORIO_EVENTOS_H
#define REPOSITORIO_EVENTOS_H

#include "Evento.h"
#include "Constantes.h"
#include "Cabecalho.h"
#include "Letra.h"
#include "Andamento.h"
#include "Nota.h"
#include "NotaSolo.h"
#include "RepositorioNotas.h"
#include "RepositorioAcordes.h"
#include "RepositorioRitmos.h"
#include "ArquivoMusica.h"
#include "SelecaoAcordeMemo.h"

class RepositorioEventos
{
    public:

        /**
         *
         */
        RepositorioEventos(char *nomeArquivo, TMemo *caixaLetra);

        /**
         *
         */
        ~RepositorioEventos();

        /**
         *
         */
        void limpar();

        /**
         *
         */
        void tocar(long timestamp);

        /**
         *
         */
        void setPosicaoAtual(long timestamp);

        void redesenhar();

        //                         
        SelecaoAcordeMemo* selecaoAcordeMemo;


        void transpor(int direcao, int numSemitons);

        /**
         *
         */
        //void refazer();

        /**
         *
         */
        //void transpor(int tom);

        /**
         *
         */
        //void alterarGrauDificuldade(...);

    private:

        //
        char *nomeArquivo;

        //
        ArquivoMusica *arquivoMusica;

        // Ou se usa um nico dicionrio com ponteiros para mtodos
        TList **dicionario;

        //
        RepositorioNotas *notas;

        //
        RepositorioRitmos *ritmos;


        // Contera o conjunto dos eventos de exibicao da melodia
        ExibicaoMelodia* exibicaoMelodia;


        //
        Letra *letra;

        //
        Andamento *andamento;

        //
        void inicializar();

        //
        void inserirListaEventos(ListaEventos *eventos);

        //
        void inserirEvento(ElementoEvento *evento);
};

#endif