/**
 * D'accord Music Software
 * http://www.daccord.com.br
 *
 * D'accord Violo
 * Definio da Classe Acorde
 *
 * Verso: 29/05/2001, 16:00
 */
#ifndef ACORDE_H
#define ACORDE_H

#include "Constantes.h"
#include "Cabecalho.h"
#include <string.h>
#include <vcl.h>

class Acorde
{
    public:

        /**
         * Construtor 'default' da classe.
         */
        Acorde(char *nome, Corda *cordas);

        /**
         *  Destrutor da classe
         */
        ~Acorde();


        /**
         *
         */
        Corda* getCordas();

        /**
         *
         */
        char* getNome();

        /**
         * Toca uma nota especfica do acorde de acordo com o dedo da mo direita.
         */
        void tocar(int dedoDireito, int volume);

        /**
         * Pra uma nota especfica do acorde, de acordo com o dedo da mo direita.
         */
        void parar(int dedoDireito);

        /**
         *
         */
        //void slide();

        /**
         *
         */
        //void bend();

        /**
         * Retona true se o acorde  um acorde "nulo" ou "em branco".
         */
         bool eAcordeNulo();

         // Retorna se o acorde eh bemol
        bool ehBemol();

        // transpoe o nome do acorde
        void transporNome(int,int,bool);

        // procura as cordas na base
        void ajustaCordas();


    private:
    /*
        char bemois[12][3];
        char susten[12][3];
    */

        /* Array das seis cordas, contendo casa, dedo da mo direita e dedo da
         * mo esquerda. */
        Corda *cordas;

        // nome do acorde.
        char *nome;

        /* Armazena as frequencias MIDI das notas, indexadas pelos dedos da mo
         * direita. */
        int *notas;

        /* Calcula as notas (frequncia MIDI) do acorde e relaciona com os dedos da mo
         * direita. */
        void calcularDedos();

        // Retorna a parte relevante do nome do acorde p/ transpor
        // ex: nome: C#m7(b5) e retorna C#
        char* filtraNome();

        // retorna o index do inicio do nome a ser passado
        //o booleano indica se o array utilizado pra busca eh o de bemois
        int getIndexNome(char*,bool);

        // retorna o inicio do nome num determinado index
        //o booleano indica se o array utilizado pra busca eh o de bemois
        char* getNomeIndex(int,bool);

        // Retorna a posicao da ultima barra, se o nome do acorde tiver
        //alguma. A ultima barra pode ser a marca do inicio da inversao.
        int getLastBar();

        // Calcula o novo index da transposicao
        // (transposicao propriamente dita. :P)
        int getNewIndex(int,int,int);

        // Recebe a tonalidade e a nota e detecta se ela eh bemol
        bool calculaBemol(int,int);

};

// Armazena o indice do acorde que ser tocado num determinado timestamp.
typedef struct EventoAcorde
{
    long timestamp;
    Acorde *acorde;
} EventoAcorde;

/* Armazena o acorde e o ndice pelo qual ele  referenciado no restante do
 * programa */
typedef struct ListaAcordes
{
    int indice;
    Acorde *acorde;
} ListaAcordes;



#endif