/**
 * D'accord Music Software
 * http://www.daccord.com.br
 *
 * D'accord Violo
 * Definio da Classe SelecaoAcordeMemo
 *
 * Verso: 16/07/2001, 16:00
 */
//---------------------------------------------------------------------------
#ifndef SelecaoAcordeMemoH
#define SelecaoAcordeMemoH
//---------------------------------------------------------------------------

#define NAO_SELECIONADO     -1

#include "Constantes.h"
#include "Letra.h"
#include <vcl.h>


typedef struct PosicaoAcordeMemo {
    int inicio,fim;
}PosicaoAcordeMemo;


class SelecaoAcordeMemo {

    public:
    /*
        Construtor
    */
    SelecaoAcordeMemo(TMemo* caixaLetra, Letra* letra);

    /*
        Destrutor
    */
    ~SelecaoAcordeMemo();

    /*
        Insere uma nova selecao, dadas as coordenadas iniciais e finais
    */
    void inserirSelecao(int inicio, int fim);

    /*
        Insere uma nova selecao, dada uma nova posicao
    */
    void inserirSelecao(PosicaoAcordeMemo* novaSelecao);

    /*
        Seleciona o acorde desejado no memo
    */
    void selecionar(int numeroAcorde);

    /*
        Desfaz a ultima selecao e seta o acorde atual pra nulo
    */
    void desfazerSelecao();

    /*
        Desenha a selecao no memo
    */
    void desenharSelecao(int inicio, int fim);

    void apagarSelecao();

    void redesenhar();

    // retorna o inicio da selecao atual
    int getInicioSel();

    void reset();

    void setPosicaoAtual(int posicao);

    // Seta as seleoces dos acordes baseadas no atributo letra da classe
    void setSelecoes();

    private:
    // Ponteiro para a caixa de letra do form principal
    TMemo* caixaLetra;
    // lista contendo todas as posicoes das selecoes de acordes no memo
    TList* listaSelecoes;
    // numero do acorde atual  -
    int selecaoAtual;
    // Canvas do paintbox do memo
    TCanvas* canvasMemo;
    // classe letra
    Letra* letra;
    // Coordenadas da selecao atual
    int inicioSel,fimSel;
    // Rect que fara a selecao
    TRect rectSelecao;
    // indica se pode redesenhar o memo
    bool podeRedesenhar;

    void scrollLetra(int numLinhas);

    // Limpa a lista de selecoes
    void clear();


};

#endif

