/**
 * D'accord Music Software
 * http://www.daccord.com.br
 *
 * D'accord Violo
 * Classe Andamento
 *
 * Verso: 21/05/2001, 10:00
 */
#include "Andamento.h"
#include "SaidaMIDI.h"

/**
 *
 */
Andamento::Andamento()
{
    andamentos = new TList;
    andamentos->Clear();
    posicaoAtual = 0;
    indice = 0;
    tamanho = 0;
}


/**
 *
 */
Andamento::~Andamento()
{
    andamentos->Clear();
    delete andamentos;
    andamentos = NULL;
}


/**
 * Seleciona a Andamento em uma posio pr definida.
 */
void Andamento::on()
{
/*
    #ifndef DEBUGANDO
    ArquivoLog::escrever("AndamentoOn\n");
    #endif
*/
    if (posicaoAtual >= 0 && posicaoAtual < tamanho)
    {
        saidaMIDI->setAndamentoMusica(
              ((ListaAndamentos *) andamentos->Items[posicaoAtual])->andamento);

        posicaoAtual++;
    }
    else // jogar excecao para que o repositorio corrija o erro.
    {
        posicaoAtual = 0;
    }
}


/**
 * Altera a posio atual do Andamento para o do timestamp recebido.
 */
void Andamento::setPosicaoAtual(long timestamp)
{
    int i = 0;

    if (timestamp == 0)    
    {
        posicaoAtual = 0;
    }
    else
    {
        // Procura uma seleo com timestamp maior que o recebido.
        while (i < tamanho 
               && ((ListaAndamentos *)andamentos->Items[i])->timestamp <= timestamp)
        {
            i++;
        }
        // Seta a posio atual para um timestamp anterior
        posicaoAtual = i - 1;
        // Garante que a posio atual est num timestamp anterior.
        /*while (posicaoAtual > 0 
               && ((ListaAndamentos *)andamentos->Items[posicaoAtual])
                  ->timestamp == timestamp)
        {
            posicaoAtual--;
        }*/
        // Faz a seleo da Andamento deste timestamp.
        on();
    }
}


/**
 * Insere um comando para alterar o andamento.
 */
void Andamento::inserir(long timestamp, int andamento)
{
    ListaAndamentos *novoAndamento = new ListaAndamentos;

    novoAndamento->timestamp = timestamp;
    novoAndamento->andamento = andamento;

    andamentos->Add(novoAndamento);
    this->tamanho++;
}

/**
 * Ordena os andamentos.
 */
void Andamento::ordenar()
{
    if (andamentos->Count > 1)
    {
        //andamentos->Sort((TListSortCompare) compararAndamentos);
        //andamentos->Pack();
    }
}


/**
 * Retorna o evento andamento.
 */
ElementoEvento* Andamento::getEventoOn()
{
    ListaAndamentos *temp;
    ElementoEvento *retorno = new ElementoEvento;

    if (indice < tamanho)
    {
        temp = (ListaAndamentos *)andamentos->Items[indice];
        retorno->timestamp = temp->timestamp;
        retorno->tipo = ON;
        retorno->evento = this;
        indice++;
    }
    else
    {   // indica que chegou ao final do repositrio.
        retorno->timestamp = FIM_REPOSITORIO;
    }
    return retorno;
}


int Andamento::getTipo()
{
    return ANDAMENTO;
}


/**
 * Mtodo Auxiliar e Global.
 * Compara duas ListaAndamentos's,  utilizada para a ordenao da lista de
 * selees.
 */
int __fastcall compararAndamentos(void *andamento1, void *andamento2)
{
    int retorno = 0;
    ListaAndamentos *and1 = (ListaAndamentos *)andamento1;
    ListaAndamentos *and2 = (ListaAndamentos *)andamento2;

    if (andamento1 == NULL)
    {
        retorno = 1;
    }
    else if (andamento2 == NULL)
    {
        retorno = -1;
    }
    else
    {
        // a prioridade  o timestamp.
        if (and1->timestamp > and2->timestamp)
        {
            retorno = 1;
        }
        else
        {
            retorno = -1;
        }
    }
    return retorno;
}