/**
 * D'accord Music Software
 * http://www.daccord.com.br
 *
 * D'accord Violo
 * Classe Letra
 *
 * Verso: 17/01/2001, 11:00
 */

#include "Evento.h"
#include "Letra.h"
#include <stdio.h>


/**
 *
 */
Letra::Letra(char *letra, TMemo *caixaLetra, TList *inicioLinhas)
{
    this->caixaLetra = caixaLetra;
    this->inicioLinhas = inicioLinhas;
    this->letra = letra;
    inicioLastSelecao = 0;
    caixaLetra->Lines->Text = letra;
    selecoes = new TList;
    selecoes->Clear();
    posicaoAtual = 0;
    tamanho = 0;
    indice = 0;
}


/**
 *
 */
Letra::~Letra()
{
    selecoes->Clear();
    delete selecoes;
    selecoes = NULL;
    delete letra;
    letra = NULL;
    delete inicioLinhas;
    inicioLinhas = NULL;
}


/**
 * Seleciona a letra em uma posio pr definida.
 */
void Letra::on()
{
    SelecaoLetra *temp;
/*
    #ifndef DEBUGANDO
    ArquivoLog::escrever("LetraOn\n");
    #endif
*/
    if (posicaoAtual >= 0 && posicaoAtual < tamanho)
    {
        //caixaLetra->SetFocus();
        temp = (SelecaoLetra *) selecoes->Items[posicaoAtual];
        if (inicioSelAcorde < temp->inicio) {
                caixaLetra->SelStart = temp->inicio;
                caixaLetra->SelLength = temp->tamanho;
        }
        posicaoAtual++;
    }
    else // jogar excecao para que o repositorio corrija o erro.
    {
        posicaoAtual = 0;
    }
}


/**
 * Altera a posio atual de seleo da letra para a do timestamp recebido.
 */
void Letra::setPosicaoAtual(long timestamp)
{
    int i = 0;

    if (timestamp == 0)
    {
        posicaoAtual = 0;
    }
    else
    {
        // Procura uma seleo com timestamp maior que o recebido.
        while (i < tamanho
               && ((SelecaoLetra *)selecoes->Items[i])->timestamp <= timestamp)
        {
            i++;
        }
        // Seta a posio atual para um timestamp anterior
        posicaoAtual = i - 1;
        // Garante que a posio atual est num timestamp anterior.
        while (posicaoAtual > 0
               && ((SelecaoLetra *)selecoes->Items[posicaoAtual])
                  ->timestamp == timestamp)
        {
            posicaoAtual--;
        }
        // Faz a seleo da letra deste timestamp.
        on();
    }
}


/**
 * Insere um comando para seleo de letra.
 */
void Letra::inserirSelecao(long timestamp, int inicio, int tamanho)
{
    SelecaoLetra *selecao = new SelecaoLetra;
    /*
    SelecaoLetra *scroll = new SelecaoLetra;
    inicioLinha *ultimaLinha;

    ultimaLinha = getLastStartOfLine(inicio);

    if(inicio < inicioLastSelecao)
    {
        listaSelecaoClear(0);
        //ultimaLinha->didScroll = false;
    }

    /*if(!ultimaLinha->didScroll)
    {
        scroll->timestamp = timestamp;
        scroll->inicio = getPosScroll(ultimaLinha->comecoLinha);
        scroll->tamanho = 0;
        selecoes->Add(scroll);
        ultimaLinha->didScroll = true;
        this->tamanho++;
    } */

    selecao->timestamp = timestamp;
    selecao->inicio = inicio;
    selecao->tamanho = tamanho;

    //inicioLastSelecao = inicio;

    selecoes->Add(selecao);
    this->tamanho++;
}

/**
 * Para ser chamada aps todos as selees terem sido inseridas. Este
 * mtodo vai inserir selees vazias que faro com que a letra aparea
 * sempre na posio correta da caixa de texto.
 */
void Letra::organizarSelecoes()
{
    int *linhas;
    int numeroLinhas = 1;
    int i = 0;
    int j = 0;

    // L a letra, contando o nmero de linhas
    while (letra[i] != '\0')
    {
        if (letra[i] == '\n')
        {
            numeroLinhas++;
        }
        i++;
    }
    // cria um array com o nmero de linhas
    linhas = new int[numeroLinhas+1];
    i = 0;
    /* L a letra mais uma vez, armazenando no array de linhas a posio inicial
     * de cada linha. */
    while (letra[i] != '\0')
    {
        if (letra[i] == '\n')
        {
            linhas[j] = i + 1;
            j++;
        }
        i++;
    }
    /* Percorre a lista de selees inserindo selees de tamanho zero duas
     * linhas abaixo de cada seleo em uma nova linha. */
    i = 0;
    j = 1;


    // ordena a seleo.
/*    if (selecoes->Count > 1)
    {
        //selecoes->Sort((TListSortCompare) compararSelecoesLetra);
        //selecoes->Pack();
    }*/
}


/**
 * Retorna a prxima lista de eventos da Letra.
 */
ListaEventos* Letra::getEventosOn()
{
    long timestampInicial;
    ListaEventos *retorno = new ListaEventos;
    ElementoListaEventos *evento;

    if (indice < tamanho)
    {
        timestampInicial = ((SelecaoLetra *)selecoes->Items[indice])->timestamp;
        retorno->timestamp = timestampInicial;
        retorno->eventos = new TList;
        retorno->eventos->Clear();
        // Percorre a lista incluindo todas as selees do mesmo timestamp.
        while (indice < tamanho && timestampInicial
                  == ((SelecaoLetra *)selecoes->Items[indice])->timestamp)
        {
            evento = new ElementoListaEventos;
            evento->evento = this;
            evento->tipo = ON;
            retorno->eventos->Add(evento);
            indice++;
        }
    }
    else
    {   // indica que chegou ao final do repositrio.
        retorno->timestamp = FIM_REPOSITORIO;
    }
    return retorno;
}

TList* Letra::getInicioLinhas()
{
    return this->inicioLinhas;
}

/*
* Recebe como argumento a posicao da selecao atual e retorna o struct q guarda
* a posicao do ultimo comeco de linha e o booleano q indica se esta linha
* jah realizou o scroll.
*/
int Letra::getLastStartOfLine(int posicaoAtual)
{
    int i,retorno = 0;
    int incremento = 0;

    for(i=0; i < inicioLinhas->Count; i++)
    {

        if(((inicioLinha*)(inicioLinhas->Items[i]))->comecoLinha + incremento <= posicaoAtual)
        {
            retorno = ((inicioLinha *) inicioLinhas->Items[i])->comecoLinha;
                                               //     + incremento;
            //lastOne->comecoLinha+=incremento;
        } else {
            break;
        }
        //incremento++;

    }
    return retorno;
}

int Letra::getLastLine(int posicaoAtual)
{
    int i,retorno = 0;
    int incremento = 0;

    for(i=0; i < inicioLinhas->Count; i++)
    {

        if(((inicioLinha*)(inicioLinhas->Items[i]))->comecoLinha + incremento <= posicaoAtual)
        {
            retorno = i;
                                               //     + incremento;
            //lastOne->comecoLinha+=incremento;
        } else {
            break;
        }
        //incremento++;

    }
    return retorno;
}


/*
* Verifica se eh possivel pular as tres linhas do scroll.
* (inicioLinhas->Count equivale ao numero de linhas.)
* se n for possivel, faz o scroll para a ultima linha.
* (inicioLinhas->Count-1)
*/
int Letra::getPosScroll(int comecoLinhaAtual)
{
    int i,retorno = comecoLinhaAtual;
    for(i=0; i < inicioLinhas->Count; i++)
    {
        if(((inicioLinha*) (inicioLinhas->Items[i]))->comecoLinha == comecoLinhaAtual)
        {
            if (i < ((inicioLinhas->Count) - 3))
            {
                retorno = ((inicioLinha*) inicioLinhas->Items[i + 3])->comecoLinha;
            }
            else
            {
                retorno = ((inicioLinha*) inicioLinhas->Items[(inicioLinhas->Count -1)])->comecoLinha;
            }
        }
    }
    return retorno;
}

int Letra::getTipo()
{
    return LETRA;
}

/*
* Desmarca todos os 'didScroll' qd a selecao
* de letra volta pra um ponto anterior na musica.
*/
void Letra::listaSelecaoClear(int start)
{
    int i;

    for(i = start ; i < inicioLinhas->Count; i++)
    {
        ((inicioLinha *) inicioLinhas->Items[i])->didScroll = false;
    }
}


/**
 * Mtodo Auxiliar e Global.
 * Compara duas SelecaoLetra's,  utilizada para a ordenao da lista de
 * selees.
 */
int __fastcall compararSelecoesLetra(SelecaoLetra *selecao1, SelecaoLetra *selecao2)
{
    int retorno = 0;
    /*SelecaoLetra *sel1 = (SelecaoLetra *)selecao1;
    SelecaoLetra *sel2 = (SelecaoLetra *)selecao2;*/

    if (selecao1 == NULL)
    {
        retorno = 1;
    }
    else if (selecao2 == NULL)
    {
        retorno = -1;
    }
    else
    {
        // a prioridade  o timestamp.
        if (selecao1->timestamp > selecao2->timestamp)
        {
            retorno = 1;
        }
        else if (selecao1->timestamp < selecao2->timestamp)
        {
            retorno = -1;
        }
        else // caso os timestamps sejam iguais,  considerado menor algum que tenha
        {    // seleo de tamanho zero.
            if (selecao1->tamanho == 0)
            {
                retorno = -1;
            }
            else if (selecao2->tamanho == 0)
            {
                retorno = 1;
            }
        }
    }
    return retorno;
}

void Letra::setInicioSelAcorde(int inicioSel) {
     this->inicioSelAcorde = inicioSel;

}

void Letra::ajustarTransposicao(TList* listNAT) {
int iNAT = 0;
int indexComecoAcorde, numRepeticoes, numEspacos;
int tNAE, tNAT, indexTemp, i, numAcordesRepetidos = 0;
bool achouColchete = false;
int lineCount = 0;
int position = 0;
AnsiString* auxiliar;
char* backupLetra;
char nomeAcordeTemp[100];

    while(iNAT < listNAT->Count && position < strlen(letra)) {
      switch (letra[position])
      {
        case '\n':
          lineCount++;
          position++;

        break;

        case ' ':
          position++;
        break;

        case '\r':
          position++;
        break;

        case '[':
          // se for linha de acorde
          if (lineCount % 3 == 0) {
            achouColchete = true;
          }
          position++;
        break;

        case ']' :
          // se for linha de acorde
          if (lineCount % 3 == 0) {
            // avanca uma posicao
            position++;
            // pula os espacos
            while(position < strlen(letra) && letra[position] == ' ') {
              position++;
            }
            // le o numero de repeticoes
            sscanf(&letra[position],"%dx",&numRepeticoes);
            // atualiza position pra depois do %dx
            position += 2;
            // dah um shift na lista de acordes transpostos
            iNAT += (numAcordesRepetidos*(numRepeticoes - 1));
            // reinicialia as duas variaveis
            numAcordesRepetidos = 0;
            achouColchete = false;
          }
          position++;
        break;

        // o caso default deve detectar o comeco de um acorde
        default:
          // se for linha de acorde.. (a linha de acorde aparece de
          //tres em tres linhas)
          if (lineCount % 3 == 0) {
            // se o acorde tiver entre colchetes..
            if(achouColchete) {
              // atualiza o numero de acordes repetidos
              numAcordesRepetidos++;
            }
            //marca o comeco do acorde
            indexComecoAcorde = position;
            // Incrementa position ateh o final do acorde encontrado
            while(      position < strlen(letra)
                                         && letra[position] != ' '
                                         && letra[position] != '\n'
                                         && letra[position] != ']'
                                         && letra[position] != '['
                                         && letra[position] != '\r') {
              position++;
            }
            if (position == strlen(letra)) {
              break;
            }
            // Calcula o tamanho do nome do acorde encontrado
            tNAE = position - indexComecoAcorde;
            // Calcula o tamanho do acorde da lista dos acordes modificados
            //for(tNAT = 0; ((char*)listNAT->Items[iNAT])[tNAT] != '\0'; tNAT++)
            //{}
            /*
                Fiz um pequeno acoxambre pra tratar dos casos dos acordes nulos
            */
            AnsiString nomeAcordeAtual = AnsiString((char*)listNAT->Items[iNAT]).Trim();
            tNAT = strlen(nomeAcordeAtual.c_str());
            /*
            Se o tamanho do nome do acorde for zero (textos como Solo, Intro,
            etc...
            */
            if (tNAT == 0) {
                // nao faz nada, soh adiantou o ponteiro position
            }
            // Se o tamanho do acorde encontrado da letra for igual ao
            //do acorde transposto q vai ser inserido
            else if(tNAE == tNAT) {
              // Copia o nome do acorde na cifra
              for(indexTemp = indexComecoAcorde, i = 0; i < tNAT; indexTemp++, i++) {
                letra[indexTemp] = (((char*)listNAT->Items[iNAT])[i]);
              }
            } else if(tNAE > tNAT) {
              // copia o nome do acorde em um nome temporario
              strcpy(nomeAcordeTemp,(char*)listNAT->Items[iNAT]);
              // se o tamanho do acorde da cifra for maior,
              // enquanto ele for maior
              while(tNAE > tNAT) {
                // adiciona espacos no final do acorde transposto, ateh q ele
                // atinja o tamanho do acorde da cifra
                strcat(nomeAcordeTemp," ");
                tNAT++;
              }
              // Copia o nome do acorde na cifra
              for(indexTemp = indexComecoAcorde, i = 0; i < tNAT; indexTemp++, i++) {
                letra[indexTemp] = (nomeAcordeTemp[i]);
              }
            } else { // se o tamanho do acorde transposto for maior...
              // calcula o numero de espacos depois do acorde na cifra
              for(indexTemp = position, numEspacos = 0; letra[indexTemp] == ' '; indexTemp++, numEspacos++)
              {}
              // se o numero de espacos for maior q diferenca de
              //tamanho dos dois acordes
              if (numEspacos > (tNAT - tNAE)) {
                // Copia o nome do acorde na cifra
                for(indexTemp = indexComecoAcorde, i = 0; i < tNAT; indexTemp++, i++) {
                  letra[indexTemp] = (((char*)listNAT->Items[iNAT])[i]);
                }
                // Ajusta o valor de position, que tinha ficado no final
                // do acorde encontrado (antes de ser substituido, qd ficou
                //maior).
                position = indexTemp;
              } else { // se n houver espacos suficientes
                // transformo a letra num ansistring
                auxiliar = new AnsiString(letra);

                //trabalhando com char*...
                //backupLetra = new char[strlen((char*)this->letra)];
                //for(i = 0; i <= position; i++) {
                //  backupLetra[i] = letra[i];
                //}
                //backupLetra[i + 1] = '\0';

                // vou usar indexTemp pra marcar o numero de espacos inseridos
                indexTemp = 0;
                // enquanto o numero de espacos n for suficiente
                while(numEspacos <= (tNAT - tNAE)) {
                  // insiro um espaco na ansiString
                  auxiliar->Insert(" ",position+1);
                  //strcat(backupLetra," ");
                  numEspacos++;
                  indexTemp++;
                }
                ajustarSelLetra(indexTemp,position);
                // Copio a AnsiString de volta na letra
                letra = new char[auxiliar->Length() + 1000];
                strcpy(letra, auxiliar->c_str());

                //Com o array de char...
                //strcat(backupLetra,&letra[position]);
                //letra = new char(strlen(backupLetra));
                //strcpy(letra,backupLetra);
                //delete backupLetra;

                // Copia o nome do acorde na cifra
                for(indexTemp = indexComecoAcorde, i = 0; i < tNAT; indexTemp++, i++) {
                letra[indexTemp] = (((char*)listNAT->Items[iNAT])[i]);
                }
                // Ajusta o valor de position, jah q o acorde inserido eh maior
                //do que o antigo
                position = indexTemp;
              }
            }

            // passa pro proximo acorde da lista dos acordes transpostos
            iNAT++;
          }
          if (letra[position] != ']') {
            position++;
          }
        break;
      }
    }
   caixaLetra->Lines->Text = letra;
}

char* Letra::getLinhaAcorde(int* pos) {
char* buffer = new char[500];
int i, enters = 0;
    while (enters <= 3) {
        if (letra[(*pos)++] == '\n') {
           enters++;
        }
    }
    // Encontrou a linha
    for(i = 0, (*pos); letra[(*pos)++] != '\n'; i++) {
        buffer[i] = letra[(*pos)];
    }
    return buffer;
}

char* Letra::getLetra() {
    return(this->letra);
}

int Letra::getTamLetra() {
    return strlen(this->letra);
}

void Letra::setInicioLinhas() {
int i = 0;

    inicioLinhas = new TList;
    while (i < strlen(letra))
    {
      if (letra[i] == '\n')
      {
        inicioLinha *inicioLinhaAtual = new inicioLinha;

        inicioLinhaAtual->comecoLinha = (i + 1);
        inicioLinhaAtual->didScroll = false;
        inicioLinhas->Add(inicioLinhaAtual);
      }
      i++;
    }
}

void Letra::ajustarSelLetra(int numShifts, int posicao) {
int i;
bool achou = false;
    i = 0;
    while(i < selecoes->Count && !achou) {
      if(((SelecaoLetra*)selecoes->Items[i])->inicio >= posicao) {
        achou = true;
        i--;
      }
      i++;
    }
    for(i ; i < selecoes->Count; i++) {
      ((SelecaoLetra*)selecoes->Items[i])->inicio += numShifts;
    }
}