/**
 * D'accord Music Software
 * http://www.daccord.com.br
 *
 * D'accord Violo
 * Definio da Classe Letra
 *
 * Verso: 11/05/2001, 17:00
 */
#ifndef LETRA_H
#define LETRA_H

#include "Constantes.h"


class Letra : public Evento
{
    public:

        /**
         * Construtor da classe.
         */
        Letra(char *letra, TMemo *caixaLetra,TList *inicioLinhas);

        /**
         *
         */
        ~Letra();

        /**
         * Seleciona a letra em uma posio pr definida.
         */
        void on();

        /**
         * Altera a posio da seleo atual para a do timestamp recebido.
         */
        void setPosicaoAtual(long timestamp);

        /**
         * No altera a posio atual da musica, s reinicia o repositrio.
         */
        void reset();

        /**
         * Insere um comando para seleo de letra.
         */
        void inserirSelecao(long timestamp, int inicio, int tamanho);

        /**
         * Para ser chamada aps todos as selees terem sido inseridas. Este
         * mtodo vai inserir selees vazias que faro com que a letra aparea
         * sempre na posio correta da caixa de texto.
         */
        void organizarSelecoes();

        /**
         * Retorna a prxima lista de eventos da Letra.
         */
        ListaEventos *getEventosOn();

        TList *getInicioLinhas();

        int getLastStartOfLine(int posicaoAtual);

        int getLastLine(int posicaoAtual);

        int getPosScroll(int linhaAtual);

        /**
         *
         */
        int getTipo();

        // seta onde o acorde atual estah comecando
        void setInicioSelAcorde(int inicio);

        // Ajusta a letra dada a lista con os novos nomes dos acordes
        void ajustarTransposicao(TList*);

        // Seta o atributo da clase, baseado do array com a cifra.
        void setInicioLinhas();

        // retorna o array com a letra
        char* getLetra();

        // Retorna o tamanho da letra
        int getTamLetra();


    private:

        void listaSelecaoClear(int);

        // Contm a letra da msica.
        char *letra;

        //
        TMemo *caixaLetra;

        /* Contm as estruturas com tamanho, posio inicial e o timestamp da
         * seleo da letra. */
        TList *selecoes;

        // guarda a posicao do comeco de cada linha.
        // array utilizado no scrool da letra
        TList *inicioLinhas;

        int inicioLastSelecao;

        // guarda o indice atual da lista de selees.
        int posicaoAtual;

        //
        int indice;

        //
        int tamanho;

        int inicioSelAcorde;
        // Retorna a linha de acordes
        char* getLinhaAcorde(int*);

        // Dah um Shift de 'int' na Selecao de Letra a partir da posicao
        //passada.
        void ajustarSelLetra(int,int);

};


// guarda os tempos de execuo de cada Letra::on.
typedef struct SelecaoLetra
{   // tempo onde  executado um determinado on.
    long timestamp;
    // posico em q este comando est armazenado na lista de indices.
    int tamanho;
    // posicao inicial da seleo.
    int inicio;
} SelecaoLetra;


/*
 * Mtodo Auxiliar e Global.
 * Compara duas SelecaoLetra's,  utilizada para a ordenao da lista de
 * selees.
 */
int __fastcall compararSelecoesLetra(SelecaoLetra *selecao1, SelecaoLetra *selecao2);

#endif