/**
 * D'accord Music Software
 * http://www.daccord.com.br
 *
 * D'accord Violo
 * Definio da Classe ExibicaoMelodia
 *
 * Verso: 29/08/2001, 24:30
 */

//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdlib.h>
#include <stdio.h>
#include "ExibicaoMelodia.h"



/**
 * Construtor da Classe
 */
ExibicaoMelodia::ExibicaoMelodia()
{
    notas = new TList;
    notas->Clear();
    eventosOn = new TList;
    eventosOn->Clear();
    indice = 0;
    tamanhoOn = 0;

    Cabeca_Gerada=NULL;
    Rabo_Gerada=NULL;
    Cabeca_Freq=NULL;
    Rabo_Freq=NULL;


}


/**
 * Destrutor da Classe
 */
ExibicaoMelodia::~ExibicaoMelodia() {

    this->limpar();
    delete notas;
    notas = NULL;
    delete eventosOn;
    eventosOn = NULL;

}


/**
 * Ainda est errado.
 */
void ExibicaoMelodia::inserir(Nota *nota, int tipoEvento, long timestamp) {
    int tamanho;
    int i = 0;
    bool existe = false;

    if (nota->getCanal() != CANAL_PADRAO) {
        return;
    }

    tamanho = notas->Count;
    // Mexe com a lista de notas
    // Verifica se a Nota j existe.
    while (i < tamanho && !existe)
    {   /* Caso a nota exista, seu timestamp  inserido na lista de eventos
         * do mesmo tipo */
        if (((Nota *)notas->Items[i])->igual(nota))
        {
            existe = true;
            //delete nota; // desaloca a nota repetida.
             // assume como nota a que j existia.
            nota = ((Nota *)notas->Items[i]);
        }
        i++;
    }
    if (!existe) /* caso a nota no exista,  inserida uma nova nota e seu */
    {            /* timestamp na lista correta */
        notas->Add(nota);
    }

    // Mexe com as listas de eventos on's ou off's
    switch (tipoEvento)
    {
        case ON: // on
            i = 0;
            existe = false;
            int frequenciaTemp = nota->getFrequencia();

            while (i < tamanhoOn && !existe)
            {   // insere a nota caso o timestamp exista
                if (((EventoNota *)eventosOn->Items[i])->timestamp
                     == timestamp)
                {
                    existe = true; // sai do loop;
                    ((EventoNota *)eventosOn->Items[i])->notas->Add(nota);
                }
                i++;
            }
            if (!existe)
            {   // insere o novo evento caso o timestamp no exista.
                EventoNota *novoEvento = new EventoNota;

                novoEvento->timestamp = timestamp;
                novoEvento->notas = new TList;
                novoEvento->notas->Clear();
                novoEvento->notas->Add(nota);

                eventosOn->Add(novoEvento);
                tamanhoOn++;
            }
            break;

        /*case : //qquer outra coisa...
            break; */
    }
}


void ExibicaoMelodia::ordenar()
{
    if (this->tamanhoOn > 1)
    {
        this->eventosOn->Sort((TListSortCompare) compararEventosNota);
    }
}


/**
 *
 */
void ExibicaoMelodia::limpar()
{
    int tamanho;
    int i;

    notas->Pack();
    tamanho = notas->Count;
    // Percorre a lista de notas destruindo cada elemento.
    for (i = 0; i < tamanho; i++)
    {
        // deleta a nota.
        delete ((Nota *)notas->Items[i]);
    }
    // limpa as lista de notas e eventos.
    notas->Clear();
    eventosOn->Clear();
    // Zera os indices e tamanhos das listas.
    indice = 0;
    tamanhoOn = 0;

     /************ DESALOCAR OS EVENTOS SOLO EM eventosExibicaoMelodiaOn e Off
    /************************
    /*****************
    /**********
    */

    // Desalocar a parte de alfredinho...
    Cabeca_Gerada=NULL;
    Rabo_Gerada=NULL;
    Cabeca_Freq=NULL;
    Rabo_Freq=NULL;



}


/**
 *
 */
void ExibicaoMelodia::reset() {
    indice = 0;
}

/**
 *  Retorna os eventos NotaSoloOn correspondentes aos notas atuais...
 */
ListaEventos* ExibicaoMelodia::getEventosExibicaoMelodia() {
    EventoNota *evento;
    int tamanho;
    int i = 0;
    ElementoListaEventos *metodoOn;
    ListaEventos *retorno = new ListaEventos;

    if (indice < tamanhoOn)
    {
        evento = new EventoNota;
        evento = (EventoNota *)eventosOn->Items[tamanhoOn - indice - 1];
        retorno->timestamp = evento->timestamp;
        retorno->eventos = new TList;
        retorno->eventos->Clear();
        metodoOn = new ElementoListaEventos;
        metodoOn->evento = ((Evento *)eventosExibicaoMelodia->Items[indice]);
        // indica que o mtodo que ser chamado  o on.
        metodoOn->tipo = ON;
        retorno->eventos->Add(metodoOn);
        indice++;
    }
    else
    {
        retorno->timestamp = FIM_REPOSITORIO;
    }
    return retorno;


}

/**
 * Cria os eventos NotaSolo correspondentes como atributo da classe
 */
void ExibicaoMelodia::gerarSolo() {
int i, conversao = 0;

    Cabeca_Gerada=NULL;
    Rabo_Gerada=NULL;
    Cabeca_Freq=NULL;
    Rabo_Freq=NULL;

    reset();

    //ordenar();
    atualizarFrequenciasMaximas();

    // Verifica os limites do violao
    if(altaFrequencia - baixaFrequencia >= 36) {

        Application->MessageBox(
        "Valores da melodia esto fora da faixa de frequncia do violo e notas podem ser perdidas.",
                                     "D'Accord Violao", 0);
        
    }
    else {
        if(altaFrequencia > 76) {
            conversao = - ((altaFrequencia-76)/12 + 1);
            Application->MessageBox(
            "Valores da melodia fora da faixa de frequncia do violo, a exibio da melodia ser transposta.",
                                     "D'Accord Violao", 0);

        } else {
            if(baixaFrequencia < 40) {
            Application->MessageBox(
            "Valores da melodia fora da faixa de frequncias do violo, a exibio da melodia ser transposta.",
                                     "D'Accord Violao", 0);
               conversao = ((40-baixaFrequencia)/12 + 1);

            }
        }
    }

    // Percorre a lista de Eventos On
    for (i=0; i < tamanhoOn; i++) {
        int novaFrequencia = getFrequenciaMaxima((EventoNota *)eventosOn->Items[i]);

        if (insereFrequencias(novaFrequencia + 12*conversao) ==
                                                          FREQUENCIA_INVALIDA) {
             eventosOn->Delete(i);
             i--;
             tamanhoOn = eventosOn->Count;
        }

    }
    if (i>0)
    escolheMelhoresPais();

}

// Atualiza as variaveis alta e baixa Frequencia
void ExibicaoMelodia::atualizarFrequenciasMaximas() {
int i;

    altaFrequencia = MENOS_INFINITO;
    baixaFrequencia = INFINITO;

    // Percorre a lista de Eventos On
    for (i=0; i < tamanhoOn; i++) {
        int novaFrequencia = getFrequenciaMaxima((EventoNota *)eventosOn->Items[i]);

        // Atualiza a mais aguda e mais grave nota do solo
        if (novaFrequencia > altaFrequencia) {
            altaFrequencia = novaFrequencia;
        }
        if (novaFrequencia < baixaFrequencia) {
            baixaFrequencia = novaFrequencia;
        }

    }

}

// Retorna a maior frequencia entre uma lista de notas
int ExibicaoMelodia::getFrequenciaMaxima(EventoNota* eventoNota) {
int tamanho = eventoNota->notas->Count;
int i;
int maximaFrequencia = MENOS_INFINITO;
int freqTemp;

    for(i=0; i < tamanho; i++) {
        freqTemp = ((Nota* )eventoNota->notas->Items[i])->getFrequencia();
        if (maximaFrequencia < freqTemp) {
            maximaFrequencia = freqTemp;

        }

    }
    return maximaFrequencia;

}



// PARTE DE ALFREDINHO...


//funcao que calcula o custo
int ExibicaoMelodia::calculaPeso(int deltaDedo, int deltaPosicao,
                                                              int deltaCorda){
    int peso;

	peso =((2*deltaPosicao)+ deltaCorda);
	return peso;
}

//funcao que insere os gerados
void ExibicaoMelodia::insereGerados(int dedo,int posicao, int corda) {
struct Nota_Gerada *armazena_gerada = NULL;

	 armazena_gerada = (struct Nota_Gerada*)malloc(sizeof(struct Nota_Gerada));

	 if(Cabeca_Gerada==NULL) {
		  armazena_gerada->dedo=dedo;
		  armazena_gerada->posicao=posicao;
		  armazena_gerada->corda=corda;
		  if((dedo==0)&&(posicao==0)&&(corda==0))
				armazena_gerada->peso=0;
		  else
				armazena_gerada->peso=0;
		  armazena_gerada->prox=NULL;
		  armazena_gerada->pai=NULL;
		  Cabeca_Gerada=armazena_gerada;
		  Rabo_Gerada=armazena_gerada;
	 }
	 else {
		  armazena_gerada->dedo=dedo;
		  armazena_gerada->posicao=posicao;
		  armazena_gerada->corda=corda;
		  armazena_gerada->peso=0;
		  armazena_gerada->pai=NULL;
		  armazena_gerada->prox=NULL;
		  Rabo_Gerada->prox=armazena_gerada;
		  Rabo_Gerada=armazena_gerada;
	 }

}//fim da funcao insere_Gerados

//funcao geradora
void ExibicaoMelodia::geradora(int frequencia) {
int i;

    //serve para inicializar a lista com zero na cabeca
    if(frequencia==0) {
        		insereGerados(0,0,0);
    }


    //respectivo a primeira corda
    if((frequencia>=64)&&(frequencia<=76)) {
        if(frequencia==64) {
             insereGerados(0,1,1);
        }
        else {

            for(i=1; i <= (frequencia-64) ;i++) {
    		    insereGerados(i,((frequencia+1)-i-64),1);
                if(i==4)
                    break;

            }
        }
    }

    //respectivo a segunda corda
    if((frequencia>=59)&&(frequencia<=71)) {
        if(frequencia==59) {
            insereGerados(0,1,2);
        }
        else {
                for(i=1;i<=frequencia-59;i++) {
                    insereGerados(i,((frequencia+1)-i-59),2);
					if(i==4)
					    break;
                }
        }

    }

    //respectivo a terceira corda
    if((frequencia>=55)&&(frequencia<=67)) {
		  if(frequencia==55) {
  			insereGerados(0,1,3);
  		  }
  		  else {
  		    for(i=1;i<=frequencia-55;i++) {
  				insereGerados(i,((frequencia+1)-i-55),3);
  				if(i==4)
  				    break;
            }
          }

  	 }

  	//respectivo a quarta corda
  	if((frequencia>=50)&&(frequencia<=62)) {
  	    if(frequencia==50) {
  		    insereGerados(0,1,4);
  		}
        else {
            for(i=1;i<=frequencia-50;i++) {
  			    insereGerados(i,((frequencia+1)-i-50),4);
  				if(i==4)
  				    break;
            }
        }

    }
  	 //respectivo a quinta corda
  	 if((frequencia>=45)&&(frequencia<=57))
  	 {
  		  if(frequencia==45)
  		  {
  				insereGerados(0,1,5);
  		  }
  		  else
  		  {
  					 for(i=1;i<=frequencia-45;i++)
  					 {
  						  insereGerados(i,((frequencia+1)-i-45),5);
  						  if(i==4)
  								break;
  					 }
  			}
  	 }

  	 //respectivo a sexta corda
  	 if((frequencia>=40)&&(frequencia<=52))
  	 {
  		  if(frequencia==40)
  		  {
  				insereGerados(0,1,6);
  		  }
  		  else
  		  {
  					 for(i=1;i<=frequencia-40;i++)
  					 {
  						  insereGerados(i,((frequencia+1)-i-40),6);
    					  if(i==4)
  								break;
  					 }
  			}
  	 }

}
//funcao que insere frequencias
int ExibicaoMelodia::insereFrequencias(int n)
{
struct Freq_Nota *armazena_frequencias=NULL;

	if((n>=40)&&(n<=76)||(n==0))
	{
		  armazena_frequencias=(struct Freq_Nota *)malloc(sizeof(struct Freq_Nota));
		  geradora(n);
		  if(Cabeca_Freq==NULL)
		  {
				armazena_frequencias->frequencia=n;
				armazena_frequencias->baixo=NULL;
				armazena_frequencias->direita=Cabeca_Gerada;
				Cabeca_Freq=armazena_frequencias;
				Rabo_Freq=armazena_frequencias;

		  }
		  else
		  {
				armazena_frequencias->frequencia=n;
				armazena_frequencias->baixo=NULL;
				armazena_frequencias->direita=Cabeca_Gerada;
				Rabo_Freq->baixo=armazena_frequencias;
				Rabo_Freq=armazena_frequencias;
			}

				Cabeca_Gerada=NULL;
                return OK;
	 } else {
       return FREQUENCIA_INVALIDA;
     }
}//fim da funcao insere frequencias

//funcao que escolhe os melhores pais e gera o arquivo de saida
void ExibicaoMelodia::escolheMelhoresPais()
{
ListaTempos *auxiliar;
struct Nota_Gerada *percorre_1=NULL,*percorre_2=NULL;
struct Freq_Nota *percorre_3=NULL;
int peso_atual;
//aqui todos os melhores pais vao ser escolhidos
//percorre1, aponta pra lista gerada acima do que percorre2 aponta;
//percorre 3 aponta pra lista de frequencias inseridas;
	 percorre_3=Cabeca_Freq;

	 while(percorre_3->baixo!=NULL)
	 {
		  percorre_1=percorre_3->direita;
		  percorre_2=percorre_3->baixo->direita;


		  while(percorre_2!=NULL)
		  {
                /*
                //Testa se eh corda solta
                if(percorre_1->posicao==0 || percorre_2->posicao==0)
                    peso_atual=Calcula_Peso(abs(percorre_1->dedo - percorre_2->dedo),0,abs(percorre_1->corda - percorre_2->corda));
                else    */   //Acoxambre pra deixar valor fixo
                peso_atual=calculaPeso(abs(percorre_1->dedo - percorre_2->dedo), percorre_1->posicao!=percorre_2->posicao?1:0,percorre_1->corda!=percorre_2->corda?1:0);
				percorre_2->peso=peso_atual + percorre_1->peso;
				percorre_2->pai=percorre_1;
				while(percorre_1!=NULL)
				{
                  /*  //Testa se eh corda solta
                    if(percorre_1->posicao==0 || percorre_2->posicao==0)
                        peso_atual=Calcula_Peso(abs(percorre_1->dedo - percorre_2->dedo),0,abs(percorre_1->corda - percorre_2->corda));
                    else     */
                	    peso_atual=calculaPeso(abs(percorre_1->dedo - percorre_2->dedo),percorre_1->posicao!=percorre_2->posicao?1:0,percorre_1->corda!=percorre_2->corda?1:0);

					if(percorre_2->peso>peso_atual + percorre_1->peso)
					{
						percorre_2->peso=peso_atual + percorre_1->peso;
						percorre_2->pai=percorre_1;
                        percorre_1=percorre_1->prox;

					}
					else
						percorre_1=percorre_1->prox;

				}

				percorre_2 = percorre_2->prox;
				percorre_1=percorre_3->direita;

		  }
		  percorre_3 = percorre_3->baixo;

	 }
	 percorre_1=Rabo_Freq->direita;
	 percorre_2=percorre_1->prox;
	 while(percorre_2 != NULL)
	 {
		  if(percorre_2->peso < percorre_1->peso)
		  {
				percorre_1=percorre_2;
				percorre_2=percorre_2->prox;
		  }
		  else
				percorre_2=percorre_2->prox;
	 }

    // inicializa a lista que contera os eventos de exibicao da melodia
    eventosExibicaoMelodia = new TList();
    // cria e insere os evento
    while (percorre_1 != NULL) {
        int casa = percorre_1->posicao+(percorre_1->dedo-1);
        int corda = percorre_1->corda-1;
        int dedo = percorre_1->dedo;
        NotaSoloMelodia* novaNota = new NotaSoloMelodia(casa, corda, dedo);
        eventosExibicaoMelodia->Add(novaNota);
        percorre_1=percorre_1->pai;

    }


}

