/**
 * D'accord Music Software
 * http://www.daccord.com.br
 *
 * D'accord Violo
 * Definio da Classe ExibicaoMelodia
 *
 * Verso: 29/08/2001, 24:30
 */

//---------------------------------------------------------------------------
#ifndef ExibicaoMelodiaH
#define ExibicaoMelodiaH

#include "Evento.h"
#include "Constantes.h"
#include "NotaSoloMelodia.h"

#define INFINITO        1000000000
#define MENOS_INFINITO  -1000000000
#define CANAL_PADRAO    14

// Definicoes usadas por alfredinho   ///////////////////
struct Nota_Gerada
{
    int dedo, posicao, corda, peso;
    struct Nota_Gerada *prox,*pai;
};

struct Freq_Nota
{
    int frequencia;
    struct Freq_Nota *baixo;
    struct Nota_Gerada *direita;
};

typedef struct ListaTempos
{
 long int timestamp;

}ListaTempos;

// fim das definicoes ////////////////////////////

/* Armazena o tempo e o evento de exibicao da melodia
*/
/*
typedef struct EventoExibicaoMelodia {
    long timestamp;
    NotaSoloMelodia* notaSoloMelodia;
} EventoExibicaoMelodia;

*/


class ExibicaoMelodia
{
    public:

        /**
         *
         */
        ExibicaoMelodia();

        /**
         *
         */
        ~ExibicaoMelodia();

        /**
         * tipoEvento: On, Off, Slide, Bend, etc...
         */
        void inserir(Nota *nota, int tipoEvento, long timestamp);

        void ordenar();

        /**
         *
         */
        void limpar();

        /**
         *
         */
        void reset();

        /**
         *  Retorna os eventos NotaSoloOn correspondentes aos notas atuais...
         */
        ListaEventos* getEventosExibicaoMelodia();

        /**
         * Cria os eventos NotaSolo correspondentes como atributo da classe
         */
        void gerarSolo();


        /**
         *
         */
        //void transpor(int tom);

        /**
         *
         */
        //void alterarGrauDificuldade(...);

    private:

        // Armazena as estruturas com as notas e seus respectivos timestamps.
        TList *notas;

        // Timestamps dos eventos On e Off.
        TList *eventosOn;

        //
        int indice;

        //
        int tamanhoOn;

        // Variaveis que contem a nota mais grave e a mais aguda da melodia escolhida
        int altaFrequencia, baixaFrequencia;

        // Contem os eventos de exibicao da melodia
        TList* eventosExibicaoMelodia;

        // Atualiza as variaveis alta e baixa Frequencia
        void atualizarFrequenciasMaximas();

        // Retorna a maior frequencia entre uma lista de notas
        int getFrequenciaMaxima(EventoNota* eventoNota);

        // Variaveis utilizadas por alfredinho...
        struct Nota_Gerada *Cabeca_Gerada, *Rabo_Gerada;
        struct Freq_Nota *Cabeca_Freq, *Rabo_Freq;


    //funcao que calcula o custo
    int calculaPeso(int deltaDedo, int deltaPosicao, int deltaCorda);

    //funcao que insere os gerados
    void insereGerados(int dedo,int posicao, int corda);

    //funcao geradora
    void geradora(int frequencia);

    //funcao que insere frequencias
    int insereFrequencias(int n);

    //funcao que escolhe os melhores pais e gera o arquivo de saida
    void escolheMelhoresPais();


};


//---------------------------------------------------------------------------
#endif
