/**
 * D'accord Music Software
 * http://www.daccord.com.br
 *
 * D'accord Violo
 * Definio da Classe NotaSolo
 *
 * Verso: 08/05/2001, 11:00
 */
#ifndef NOTA_SOLO_H
#define NOTA_SOLO_H

#include "Evento.h"
#include "Nota.h"

class NotaSolo : public Nota
{
    public:

        /**
         * Construtor da Classe.
         *
         * Parmetros:
         *      casa: casa no brao do violo onde o solo ser tocado.
         *      corda: corda do violo onde a nota ser tocada.
         *      dedo: dedo utilizado
         */
        NotaSolo(int casa, int corda, int dedo);

        /**
         * Destrutor da Classe.
         */
        ~NotaSolo();

        /**
         * Toca a nota j definida e a mostra na tela.
         */
        void on();

        /**
         * Para de tocar a nota e apaga da tela.
         */
        void off();

        /**
         * Compara duas notas.
         */
        bool igual(Nota *nota);

        /**
         *
         */
        int getTipo();



    protected:

        // Corda onde a nota ser tocada
        int corda;

        // Casa onde a nota ser tocada.
        int casa;

        // Dedo utilizado pra tocar
        int dedo;
};

#endif