/**
 * D'accord Music Software
 * http://www.daccord.com.br
 *
 * D'accord Violo
 * Classe RepositorioNotas
 *
 * Verso: 07/05/2001, 16:00
 */
#include "RepositorioNotas.h"


/**
 * Construtor da Classe
 */
RepositorioNotas::RepositorioNotas()
{
    notas = new TList;
    notas->Clear();
    eventosOn = new TList;
    eventosOn->Clear();
    eventosOff = new TList;
    eventosOff->Clear();
    indiceOn = 0;
    tamanhoOn = 0;
    indiceOff = 0;
    tamanhoOff = 0;
}


/**
 * Destrutor da Classe
 */
RepositorioNotas::~RepositorioNotas()
{
    this->limpar();
    delete notas;
    notas = NULL;
    delete eventosOn;
    eventosOn = NULL;
    delete eventosOff;
    eventosOff = NULL;
}


/**
 * Ainda est errado.
 */
void RepositorioNotas::inserir(Nota *nota, int tipoEvento, long timestamp)
{
    int tamanho;
    int i = 0;
    bool existe = false;

    tamanho = notas->Count;
    /* Mexe com a lista de notas */
    /* Verifica se a Nota j existe. */
    while (i < tamanho && !existe)
    {   /* Caso a nota exista, seu timestamp  inserido na lista de eventos
         * do mesmo tipo */
        if (((Nota *)notas->Items[i])->igual(nota))
        {
            existe = true;
            delete nota; // desaloca a nota repetida.
             // assume como nota a que j existia.
            nota = ((Nota *)notas->Items[i]);
        }
        i++;
    }
    if (!existe) /* caso a nota no exista,  inserida uma nova nota e seu */
    {            /* timestamp na lista correta */
        notas->Add(nota);
    }

    // Mexe com as listas de eventos on's ou off's
    switch (tipoEvento)
    {
        case ON: // on
            i = 0;
            existe = false;
            while (i < tamanhoOn && !existe)
            {   // insere a nota caso o timestamp exista
                if (((EventoNota *)eventosOn->Items[i])->timestamp
                     == timestamp)
                {
                    existe = true; // sai do loop;
                    ((EventoNota *)eventosOn->Items[i])->notas->Add(nota);
                }
                i++;
            }
            if (!existe)
            {   // insere o novo evento caso o timestamp no exista.
                EventoNota *novoEvento = new EventoNota;

                novoEvento->timestamp = timestamp;
                novoEvento->notas = new TList;
                novoEvento->notas->Clear();
                novoEvento->notas->Add(nota);

                eventosOn->Add(novoEvento);
                tamanhoOn++;
            }
            break;
        case OFF: // off
            i = 0;
            existe = false;
            while (i < tamanhoOff && !existe)
            {   // insere a nota caso o timestamp exista
                if (((EventoNota *)eventosOff->Items[i])->timestamp
                     == timestamp)
                {
                    existe = true; // sai do loop;
                    ((EventoNota *)eventosOff->Items[i])->notas->Add(nota);
                }
                i++;
            }
            if (!existe)
            {   // insere o novo evento caso o timestamp no exista.
                EventoNota *novoEvento = new EventoNota;

                novoEvento->timestamp = timestamp;
                novoEvento->notas = new TList;
                novoEvento->notas->Clear();
                novoEvento->notas->Add(nota);

                eventosOff->Add(novoEvento);
                tamanhoOff++;
            }
            break;
        /*case : //qquer outra coisa...
            break; */
    }
}


void RepositorioNotas::ordenar()
{
    if (this->tamanhoOn > 1)
    {
        this->eventosOn->Sort((TListSortCompare) compararEventosNota);
    }
    if (this->tamanhoOff > 1)
    {
        this->eventosOff->Sort((TListSortCompare) compararEventosNota);
    }
}


/**
 *
 */
void RepositorioNotas::limpar()
{
    int tamanho;
    int i;

    notas->Pack();
    tamanho = notas->Count;
    // Percorre a lista de notas destruindo cada elemento.
    for (i = 0; i < tamanho; i++)
    {
        // deleta a nota.
        delete ((Nota *)notas->Items[i]);
    }
    // limpa as lista de notas e eventos.
    notas->Clear();
    eventosOn->Clear();
    eventosOff->Clear();
    // Zera os indices e tamanhos das listas.
    indiceOn = 0;
    indiceOff = 0;
    tamanhoOn = 0;
    tamanhoOff = 0;
}


/**
 *
 */
void RepositorioNotas::reset()
{
    indiceOn = 0;
    indiceOff = 0;
}


/**
 *
 */
ListaEventos* RepositorioNotas::getEventosOn()
{
    EventoNota *evento;
    int tamanho;
    int i = 0;
    ElementoListaEventos *metodoOn;
    ListaEventos *retorno = new ListaEventos;

    if (indiceOn < tamanhoOn)
    {
        evento = new EventoNota;
        evento = (EventoNota *)eventosOn->Items[indiceOn];
        retorno->timestamp = evento->timestamp;
        retorno->eventos = new TList;
        retorno->eventos->Clear();
        indiceOn++;
        /* Transforma a lista de notas em lista de referncias para estruturas do
         * tipo ElementoListaEventos */
        tamanho = evento->notas->Count;
        for (i = 0; i < tamanho; i++)
        {
            metodoOn = new ElementoListaEventos;
            metodoOn->evento = ((Evento *)evento->notas->Items[i]);
            // indica que o mtodo que ser chamado  o on.
            metodoOn->tipo = ON;
            retorno->eventos->Add(metodoOn);
        }
    }
    else
    {
        retorno->timestamp = FIM_REPOSITORIO;
    }
    return retorno;
}


/**
 *
 */
ListaEventos* RepositorioNotas::getEventosOff()
{
    EventoNota *evento;
    int tamanho;
    int i = 0;
    ElementoListaEventos *metodoOff;
    ListaEventos *retorno = new ListaEventos;

    if (indiceOff < tamanhoOff)
    {
        evento = new EventoNota;
        evento = (EventoNota *)eventosOff->Items[indiceOff];
        retorno->timestamp = evento->timestamp;
        retorno->eventos = new TList;
        retorno->eventos->Clear();
        indiceOff++;
        /* Transforma a lista de notas em lista de referncias para estruturas do
         * tipo ElementoListaEventos */
        tamanho = evento->notas->Count;
        for (i = 0; i < tamanho; i++)
        {
            metodoOff = new ElementoListaEventos;
            metodoOff->evento = ((Evento *)evento->notas->Items[i]);
            // indica que o mtodo que ser chamado  o off.
            metodoOff->tipo = OFF;
            retorno->eventos->Add(metodoOff);
        }
    }
    else
    {
        retorno->timestamp = FIM_REPOSITORIO;
    }
    return retorno;
}


/**
 * Preenche os eventos da classe Exibicao melodia
 */
void RepositorioNotas::preencherEventosExibicaoMelodia(ExibicaoMelodia**
                                                            exibicaoMelodia) {
int i,j, tamanhoNotas;
long timestamp;
EventoNota* eventoTemp;

    for (i = 0; i < tamanhoOn; i++) {
        eventoTemp = (EventoNota* )eventosOn->Items[i];
        timestamp = eventoTemp->timestamp;
        tamanhoNotas = eventoTemp->notas->Count;
        for (j = 0; j < tamanhoNotas; j++)
        {
            (*exibicaoMelodia)->inserir((Nota *)eventoTemp->notas->Items[j],
                                                                ON, timestamp);
        }

    }

}
//---------------------------------------------------------------------------
void RepositorioNotas::transpor(int direcao, int numSemitons)
{
int i;
Nota* notaTemp;
    // para cada nota do array 'notas'
    for(i = 0; i < notas->Count; i++) {
          notaTemp = (Nota*) notas->Items[i];
          // se o canal nao for o da bateria
          if(notaTemp->getCanal() != CANAL_BATERIA) {
              switch (direcao)
              {
                // se a transposicao for acima
                case ACIMA:
                  // a nota aumenta de frequencia de acordo com o numSemitons
                  notaTemp->setNota(notaTemp->getNota() + numSemitons);
                  // se a frenquencia passar de 127, ela eh ajustada
                  if(notaTemp->getNota() > 127) {
                    notaTemp->setNota(127);
                  }
                break;
                // se a transposicao for abaixo
                case ABAIXO:
                  // a nota diminui de frequencia
                  notaTemp->setNota(notaTemp->getNota() - numSemitons);
                  // se a frequencia ficar menor que zero, ela eh ajustada
                  if(notaTemp->getNota() < 0) {
                    notaTemp->setNota(0);
                  }
                break;
              }
          }
    }
}

