/**
 * D'accord Music Software
 * http://www.daccord.com.br
 *
 * D'accord Violo
 * Definio da Classe RepositorioNotas
 *
 * Verso: 11/05/2001, 17:00
 */
#ifndef REPOSITORIO_NOTAS_H
#define REPOSITORIO_NOTAS_H

#include "Evento.h"
#include "Constantes.h"
#include "Nota.h"
#include "NotaSolo.h"
#include "ExibicaoMelodia.h"

class RepositorioNotas
{
    public:

        /**
         *
         */
        RepositorioNotas();

        /**
         *
         */
        ~RepositorioNotas();

        /**
         * tipoEvento: On, Off, Slide, Bend, etc...
         */
        void inserir(Nota *nota, int tipoEvento, long timestamp);

        /**
         * Retorna a prxima lista de eventos do repositrio.
         */
        ListaEventos *getEventosOn();

        /**
         * Retorna a prxima lista de eventos do repositrio.
         */
        ListaEventos *getEventosOff();


        void ordenar();

        /**
         *
         */
        void limpar();

        /**
         *
         */
        void reset();

        /**
         * Preenche os eventos da classe Exibicao melodia
         */
        void preencherEventosExibicaoMelodia(ExibicaoMelodia** exibicaoMelodia);

        //---------------------------------------------------------------------------
        void transpor(int direcao, int numSemitons);

        /**
         *
         */
        //void transpor(int tom);

        /**
         *
         */
        //void alterarGrauDificuldade(...);

    private:
        // Armazena as estruturas com as notas e seus respectivos timestamps.
        TList *notas;

        // Timestamps dos eventos On e Off.
        TList *eventosOn;
        TList *eventosOff;

        //
        int indiceOn;
        int indiceOff;

        //
        int tamanhoOn;
        int tamanhoOff;
};

#endif