/**
 * D'accord Music Software
 * http://www.daccord.com.br
 *
 * D'accord Violo
 * Definio da Classe NotaRitmo
 *
 * Verso: 29/05/2001, 16:00
 */
#ifndef NOTA_RITMO_H
#define NOTA_RITMO_H

#include "Evento.h"
#include "RepositorioAcordes.h"

class NotaRitmo : public Evento
{
    public:

        /**
         * Construtor da Classe.
         *
         * Parmetros:
         *      dedoDireito: dedo da mo direita utilizado
         *      volume: intensidade (velocity) da nota tocada.
         */
        NotaRitmo(int dedoDireito, int volume);

        ~NotaRitmo();
        
        /**
         * Toca a nota j definida e a mostra na tela.
         */
        void on();

        /**
         * Para de tocar a nota e apaga da tela.
         */
        void off();

        /**
         *
         */
        int getTipo();

    private:

        // Intensidade (velocity) no qual a nota ser tocada.
        int volume;

        // Dedo da mo direita utilizado pra tocar
        int dedoDireito;
};

#endif