/**
 * D'accord Music Software
 * http://www.daccord.com.br
 *
 * D'accord Violo
 * Definio da Classe RepositorioRitmos
 *
 * Verso: 28/05/2001, 12:00
 */
#ifndef REPOSITORIO_RITMO_H
#define REPOSITORIO_RITMO_H

#include "Ritmo.h"
#include "Constantes.h"
#include <vcl.h>

class RepositorioRitmos
{
    public:

        /**
         *
         */
        RepositorioRitmos();

        /**
         *
         */
        ~RepositorioRitmos();

        /**
         * Insere um ritmo no repositrio. O indice recebido ser o ndice pelo
         * qual este ritmo ser referenciado no restante do programa.
         */
        void inserir(Ritmo *ritmo, int indice);

        /**
         * Insere um ritmo no repositrio. Este ritmo ser procurado na base
         * por indiceBase, e tratado no restante do programa por indice.
         */
        //void inserir(int indiceBase, int indice);

        /**
         * Insere um evento para um ritmo da base. O ndice recebido indica a
         * qual o ritmo o evento ser aplicado.
         * tipoEvento: On, Off, Slide, Bend, etc...
         */
        void inserirEvento(int indice/*, int tipoEvento*/, long timestamp);

        /**
         * Retorna a prxima lista de eventos do repositrio.
         */
        ListaEventos *getEventosOn();

        /**
         * Retorna a prxima lista de eventos do repositrio.
         */
        ListaEventos *getEventosOff();

        /**
         *
         */
        void montarRepositorio();

        /**
         *
         */
        void ordenar();

        /**
         *
         */
        void limpar();

        /**
         *
         */
        void reset();

    private:
        // Armazena as estruturas com os ritmos e seus respectivos timestamps.
        TList *ritmos;

        // Armazena as estruturas dos eventos: acordes e timestamps.
        TList *eventos;

        // Guarda o ndice atual da lista de eventos.
        int indiceListaEventos;

        // Guarda o tamanho da lista de eventos.
        int tamanhoListaEventos;

        // guarda o tamanho da lista de acordes.
        int tamanhoListaRitmos;

        // Contatena uma lista de eventos a lista original.
        void adicionarListaOn(TList *eventosOn);
        void adicionarListaOff(TList *eventosOff);

        // Timestamps dos eventos On e Off.
        TList *eventosOn;
        TList *eventosOff;

        // Indice da lista de eventos on e off
        int indiceOn;
        int indiceOff;

        // Tamanho das listas de eventos on e off.
        int tamanhoOn;
        int tamanhoOff;
};

#endif