/**
 * D'accord Music Software
 * http://www.daccord.com.br
 *
 * D'accord Violo
 * Classe Ritmo
 *
 * Verso: 29/05/2001, 16:00
 */
#include "Ritmo.h"
#include "NotaRitmo.h"

/**
 *
 */
Ritmo::Ritmo(char *nome, long ultimoTimestamp, Compasso *compasso,
             int numeroEventos, ElementoRitmo *elementosRitmo)
{
    this->nome = nome;
    this->ultimoTimestamp = ultimoTimestamp;
    this->compasso = compasso;
    this->numeroEventos = numeroEventos;
    this->elementosRitmo = elementosRitmo;
}

Ritmo::~Ritmo() {

    delete[] this->nome;
    delete[] this->elementosRitmo;
    delete this->compasso;
}


/**
 *
 */
/*char* Ritmo::getNome()
{
    return nome;
} */

/**
 *
 */
ElementoRitmo* Ritmo::getElementosRitmo()
{
    return elementosRitmo;
}

/**
 *
 */
int Ritmo::getNumeroEventos()
{
    return numeroEventos;
}

/**
 *
 */
long Ritmo::getUltimoTimestamp()
{
    return ultimoTimestamp;
}

/**
 *
 */
TList* Ritmo::getEventosOn(long timestampInicial, long timestampFinal) {

    TList *retorno = new TList;
    ListaEventos *temp;
    ElementoListaEventos *metodoOn;
    NotaRitmo *tempNota;
    bool adicionouNota;
    int i = 0;
    long timestampAtual = 0;
    retorno->Clear();

    // Percorre a estrutura at que todo o intervalo tenha sido preenchido
    while (timestampInicial <= timestampFinal) {    
        // Percorre a estrutura procurando notas on
        while (i < numeroEventos && timestampAtual <= timestampFinal) {
            // cria uma nova lista de eventos...
            temp = new ListaEventos;
            temp->eventos = NULL;
            adicionouNota = false;
            timestampAtual = timestampInicial 
                             + ((ElementoRitmo) elementosRitmo[i]).timestamp;
            temp->timestamp = timestampAtual;
            // enquanto houverem notas no mesmo timestamp...
            while (i < numeroEventos
                   && (((ElementoRitmo) elementosRitmo[i]).timestamp
                   + timestampInicial) == timestampAtual) {
                // se for uma NotaRitmo::on()
                if (((ElementoRitmo) elementosRitmo[i]).volume != 0) {
                    // cria a NotaRitmo
                    tempNota = new NotaRitmo(
                        ((ElementoRitmo) elementosRitmo[i]).dedoDireito,
                        ((ElementoRitmo) elementosRitmo[i]).volume);
                    // Cria um novo elemento para ser tocardo (est. de execuo)
                    metodoOn = new ElementoListaEventos;
                    metodoOn->tipo = ON; // indica o tipo do mtodo.
                    metodoOn->evento = tempNota;
                    // caso a lista ainda esteja vazia, inicializa.
                    if (temp->eventos == NULL) {
                        temp->eventos = new TList;
                        temp->eventos->Clear();
                    }
                    // Adiciona o novo evento  lista.
                    temp->eventos->Add(metodoOn);
                    adicionouNota = true;
                }
                i++;
            }
            if (adicionouNota && temp->timestamp <= timestampFinal) {
                retorno->Add(temp);
            }
        }
        timestampInicial = timestampInicial + ultimoTimestamp;
        i = 0;
    }
    return retorno;
}

/**
 *
 */
TList* Ritmo::getEventosOff(long timestampInicial, long timestampFinal) {

    TList *retorno = new TList;
    ListaEventos *temp;
    ElementoListaEventos *metodoOff;
    NotaRitmo *tempNota;
    bool adicionouNota;
    int i = 0;
    long timestampAtual = 0;
    retorno->Clear();

    // Percorre a estrutura at que todo o intervalo tenha sido preenchido
    while (timestampInicial <= timestampFinal) {    
        // Percorre a estrutura procurando notas off
        while (i < numeroEventos && timestampAtual <= timestampFinal) {
            // cria uma nova lista de eventos...
            temp = new ListaEventos;
            temp->eventos = NULL;
            adicionouNota = false;
            timestampAtual = timestampInicial 
                             + ((ElementoRitmo) elementosRitmo[i]).timestamp;
            temp->timestamp = timestampAtual;
            // enquanto houverem notas no mesmo timestamp...
            while (i < numeroEventos
                   && (((ElementoRitmo) elementosRitmo[i]).timestamp
                   + timestampInicial) == timestampAtual) {
                // se for uma NotaRitmo::off()
                if (((ElementoRitmo) elementosRitmo[i]).volume == 0) {
                    // cria a NotaRitmo
                    tempNota = new NotaRitmo(
                        ((ElementoRitmo) elementosRitmo[i]).dedoDireito,
                        ((ElementoRitmo) elementosRitmo[i]).volume);
                    // Cria um novo elemento para ser tocardo (est. de execuo)
                    metodoOff = new ElementoListaEventos;
                    metodoOff->tipo = OFF; // indica o tipo do mtodo.
                    metodoOff->evento = tempNota;
                    // caso a lista ainda esteja vazia, inicializa.
                    if (temp->eventos == NULL) {
                        temp->eventos = new TList;
                        temp->eventos->Clear();
                    }
                    // Adiciona o novo evento  lista.
                    temp->eventos->Add(metodoOff);
                    adicionouNota = true;
                }
                i++;
            }
            if (adicionouNota && temp->timestamp <= timestampFinal) {
                retorno->Add(temp);
            }
        }
        timestampInicial = timestampInicial + ultimoTimestamp;
        i = 0;
    }
    return retorno;
}