/**
 * D'accord Music Software
 * http://www.daccord.com.br
 *
 * D'accord Violo
 * Definio da Classe Ritmo
 *
 * Verso: 29/05/2001, 16:00
 */
#ifndef RITMO_H
#define RITMO_H

#include "Constantes.h"
#include <vcl.h>

class Ritmo
{
    public:

        /**
         * Construtor 'default' da classe.
         */
        Ritmo(char *nome, long ultimoTimestamp, Compasso *compasso,
              int numeroEventos, ElementoRitmo *elementosRitmo);

        /**
         * Destrutor
         */
        ~Ritmo();


        /**
         *
         */
        //char* getNome();

        /**
         *
         */
        ElementoRitmo* getElementosRitmo();

        /**
         *
         */
        int getNumeroEventos();

        /**
         *
         */
        //Compasso getCompasso();

        /**
         *
         */
        long getUltimoTimestamp();

        /**
         *
         */
        TList *getEventosOn(long timestampInicial, long timestampFinal);

        /**
         *
         */
        TList *getEventosOff(long timestampInicial, long timestampFinal);

        /**
         *
         */
        //void slide();

        /**
         *
         */
        //void bend();

    private:

        // nome do ritmo.
        char *nome;

        // ltimo timestamp do ritmo.
        long ultimoTimestamp;

        // Compasso da msica.
        Compasso *compasso;

        // Nmero de eventos.
        int numeroEventos;

        /* Armazena os 'pedaos' do ritmo, sendo o timestamp proporcional ao inicio
         * do mesmo. */
        ElementoRitmo *elementosRitmo;
};

// Armazena o indice do ritmo que ser tocado num determinado timestamp.
typedef struct EventoRitmo
{
    long timestamp;
    Ritmo *ritmo;
} EventoRitmo;

/* Armazena o ritmo e o ndice pelo qual ele  referenciado no restante do
 * programa */
typedef struct ListaRitmos
{
    int indice;
    Ritmo *ritmo;
} ListaRitmos;

#endif